import javax.swing.*;
import java.awt.*;

public class BildAnzeige extends JFrame {

    Image img = null;
    String dateiName = null;
    public BildAnzeige() {
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setTitle("Bildanzeige mit Java");
        setSize(400, 300);
        setVisible(true);
        // Dateiauswahl bei Fensterstart
        JFileChooser openDialog = new JFileChooser();
        int wahl = openDialog.showOpenDialog(this);
        if (wahl==JFileChooser.APPROVE_OPTION) {
            // Dateiname und Image festhalten
            dateiName = openDialog.getSelectedFile().getAbsolutePath();
            img = Toolkit.getDefaultToolkit().getImage(dateiName);
            repaint(); // neuzeichnen erzwingen
        }
    }

    @Override public void paint(Graphics g) {
        // Zeichenausschnitt ermitteln
        Insets insets = getInsets();
        int links  = insets.left;
        int oben   = insets.top;
        int breite = getSize().width-insets.left-insets.right;
        int hoehe  = getSize().height-insets.top-insets.bottom;
        g.clearRect(links, oben, breite-1, hoehe-1);
        g.setClip(30, 30, 240, 120);
        // Bild anzeigen
        if (img!=null) {
            g.drawImage(img, links, oben, this);
        }
        g.setColor(Color.BLACK);
        g.drawString("Norgaardholz", links, oben+30);
        g.copyArea(links, oben, 400, 400, 150, 100);

    }

    public static void main(String[] args) {
        new BildAnzeige();
    }
}

