import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class KlickRechteck extends JFrame
             implements MouseListener {

    private int letztX=0, letztY=0;
    private int jetztX=0, jetztY=0;

    public KlickRechteck() {
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setTitle("Klick-Rechteck");
        setSize(400, 300);
        setVisible(true);
        addMouseListener(this);
    }

    public void mousePressed(MouseEvent ev) { }
    public void mouseReleased(MouseEvent ev) { }
    public void mouseExited(MouseEvent ev) { }
    public void mouseEntered(MouseEvent ev) { }

    public void mouseClicked(MouseEvent ev) {
        letztX = jetztX;
        letztY = jetztY;
        jetztX = ev.getX();
        jetztY = ev.getY();
        repaint(); // Erzwinge Neuzeichnen
    }

    public void paint(Graphics g) {
        // Bildschirm freimachen
        Insets insets = getInsets();
        g.clearRect(insets.left, insets.top,
            getSize().width  - insets.left - insets.right,
            getSize().height - insets.top  - insets.bottom);

        int x = letztX;
        int y = letztY;
        if (x > jetztX) {
            x = jetztX;
        }
        if (y > jetztY) {
            y = jetztY;
        }
        int breite = Math.abs(letztX - jetztX);
        int hoehe = Math.abs(letztY - jetztY);
        g.drawRect(x, y, breite, hoehe);
    }

    public static void main(String[] args) {
        new KlickRechteck();
    }
}

