import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class MauseSchwanz extends JFrame
             implements MouseMotionListener {

    class Linie {
        int xAnf=0,yAnf=0;
        int xEnde=0,yEnde=0;
    }

    private final int MAXPOS = 30;
    private int indexPos = 0;
    private Linie []linie;
    private int letztX, letztY;

    public MauseSchwanz() {
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        linie = new Linie[MAXPOS];
        for (int i=0; i<MAXPOS; i++) {
            linie[i] = new Linie();
        }
        addMouseMotionListener(this);
    }

    public void mouseDragged(MouseEvent ev) { }

    public void mouseMoved(MouseEvent ev) {
        linie[indexPos].xEnde = letztX;
        linie[indexPos].yEnde = letztY;
        linie[indexPos].xAnf = letztX = ev.getX();
        linie[indexPos].yAnf = letztY = ev.getY();
        indexPos++;
        if (indexPos>=MAXPOS) {
            indexPos = 0;
        }
        repaint(); // Erzwinge Neuzeichnen
    }

    public void paint(Graphics g) {
        // Bildschirm freimachen
        Insets insets = getInsets();
        g.clearRect(insets.left, insets.top,
            getSize().width  - insets.left - insets.right,
            getSize().height - insets.top  - insets.bottom);

        // die aelteren Linien zeichnen
        for (int i=indexPos; i<MAXPOS; i++) {
            g.drawLine(linie[i].xAnf, linie[i].yAnf,
                       linie[i].xEnde, linie[i].yEnde);
        }
        // die neuesten Linien zeichnen
        for (int i=0; i<indexPos; i++) {
            g.drawLine(linie[i].xAnf, linie[i].yAnf,
                       linie[i].xEnde, linie[i].yEnde);
        }
    }

    public static void main(String[] args) {
        MauseSchwanz fenster = new MauseSchwanz();
        fenster.setTitle("Mausschlaengeln mit Java");
        fenster.setSize(400, 300);
        fenster.setVisible(true);
    }
}

