import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

public class BermudaImage extends JFrame
                          implements MouseListener {
    SpielFeld spielfeld = null;
Image leer, schiff, ziffer[];

    public static void main(String[] args) {
        BermudaImage fenster = new BermudaImage();
    }

    public BermudaImage() {
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        addMouseListener(this); // fange die Mausereignisse
        spielfeld = new SpielFeld();
        setTitle("Bermuda");
        setSize((spielfeld.MaxX+2)*DISTANZ,
                (spielfeld.MaxY+4)*DISTANZ);
        setVisible(true);
        leer = Toolkit.getDefaultToolkit().getImage("leer.png");
        schiff = Toolkit.getDefaultToolkit().getImage("schiff.png");
        ziffer = new Image[9];
        for (int i=0; i<9; i++) {
            ziffer[i] = Toolkit.getDefaultToolkit().getImage("mark"+i+".png");
        }
    }
    Insets in;
    boolean spielEnde = false;
    String statusStr = "                ";
    final int DISTANZ = 32;
    @Override public void paint(Graphics g) {
        in = getInsets();
        g.clearRect(in.left, in.top, getSize().width,
                                     getSize().height);
        for (int i=0; i<spielfeld.MaxX; i++) {
            for (int j=0; j<spielfeld.MaxY; j++) {
                char c = spielfeld.get(i, j);
                Image img=null;
                if (c >='0' && c <='8') {
                    img = ziffer[c-'0'];
                } else if (c==spielfeld.SCHIFF) {
                    img = schiff;
                } else {
                    img = leer;
                }
                g.drawImage(img,
                            in.left+(i+1)*DISTANZ-DISTANZ/2,
                            in.top+(j+1)*DISTANZ-DISTANZ/2,
                            this);
            }
        }
    }
    @Override public void mouseClicked(MouseEvent me) {
        if (!spielEnde) {
            int suchX = (me.getX()-in.left-DISTANZ/2)/DISTANZ;
            int suchY = (me.getY()-in.top-DISTANZ/2)/DISTANZ;
            if (suchX>=0 && suchY>=0 && suchX<spielfeld.MaxX
                         && suchY<spielfeld.MaxY) {
                char c = spielfeld.suche(suchX, suchY);
                if (c==spielfeld.SCHIFF) {
                    if (spielfeld.alleGefunden()) {
                        spielEnde = true;
                        statusStr =
                            "Gewonnen! Mausklick: neues Spiel";
                    }
                }
            }
        } else {
            // sonderfall: Mausklick, um Sieg zu bestaetigen
            spielEnde = false;
            statusStr = "                  ";
            spielfeld = new SpielFeld();
        }
        repaint();
    }
    public void mouseReleased(MouseEvent me) { }
    public void mousePressed(MouseEvent me)  { }
    public void mouseEntered(MouseEvent me)  { }
    public void mouseExited(MouseEvent me)   { }
}

