import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

public class BermudaSwing extends JFrame
                          implements MouseListener {
    SpielFeld spielfeld = null;
    public static void main(String[] args) {
        BermudaSwing fenster = new BermudaSwing();
    }

    public BermudaSwing() {
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        addMouseListener(this); // fange die Mausereignisse
        spielfeld = new SpielFeld();
        setTitle("Bermuda");
        setSize((spielfeld.MaxX+2)*DISTANZ,
                (spielfeld.MaxY+4)*DISTANZ);
        setVisible(true);
    }
    final int DISTANZ = 16;
    Insets in;
    boolean spielEnde = false;
    String statusStr = "                ";
    @Override public void paint(Graphics g) {
        in = getInsets();
        g.clearRect(in.left, in.top, getSize().width,
                                     getSize().height);
        String str;
        for (int i=0; i<spielfeld.MaxX; i++) {
            for (int j=0; j<spielfeld.MaxY; j++) {
                str = String.valueOf(spielfeld.get(i,j));
                g.drawString(str, in.left+(i+1)*DISTANZ,
                                  in.top+(j+1)*DISTANZ);
            }
        }
        g.drawString(statusStr,
                     in.left,
                     in.top + (spielfeld.MaxY+1) * DISTANZ);
    }
    @Override public void mouseClicked(MouseEvent me) {
        if (!spielEnde) {
            int suchX = (me.getX()-in.left-DISTANZ/2)/DISTANZ;
            int suchY = (me.getY()-in.top-DISTANZ/2)/DISTANZ;
            if (suchX>=0 && suchY>=0 && suchX<spielfeld.MaxX
                         && suchY<spielfeld.MaxY) {
                char c = spielfeld.suche(suchX, suchY);
                if (c==spielfeld.SCHIFF) {
                    if (spielfeld.alleGefunden()) {
                        spielEnde = true;
                        statusStr =
                            "Gewonnen! Mausklick: neues Spiel";
                    }
                }
            }
        } else {
            // sonderfall: Mausklick, um Sieg zu bestaetigen
            spielEnde = false;
            statusStr = "                  ";
            spielfeld = new SpielFeld();
        }
        repaint();
    }
    public void mouseReleased(MouseEvent me) { }
    public void mousePressed(MouseEvent me)  { }
    public void mouseEntered(MouseEvent me)  { }
    public void mouseExited(MouseEvent me)   { }
}

