import javax.swing.*;
import java.awt.GridLayout;
import java.awt.BorderLayout;
import java.awt.event.*;

public class BMI extends JFrame implements ActionListener {
  JTextField txtGroesse, txtGewicht;
  JLabel labMeldung, labBmi;

  public BMI() {
    JLabel labGroesse, labGewicht;
    JButton btnStart;

    setDefaultCloseOperation(EXIT_ON_CLOSE);
    // der Hauptcontainer bekommt ein Borderlayout.
    setLayout(new BorderLayout());
    JPanel innen = new JPanel();
    add(innen, BorderLayout.CENTER);
    innen.setLayout(new GridLayout(3, 2));
    // erzeuge die Kontrollelemente
    labGroesse = new JLabel("Groesse (cm):");
    labGewicht = new JLabel("Gewicht (kg):");
    labMeldung = new JLabel(" ");
    labBmi = new JLabel(" ");
    txtGroesse = new JTextField();
    txtGewicht = new JTextField();
    btnStart = new JButton("OK");
    // nur der Button ist aktiv
    btnStart.addActionListener(this);
    // Zusammenbau aller Elemente
    innen.add(labGroesse);
    innen.add(txtGroesse);
    innen.add(labGewicht);
    innen.add(txtGewicht);
    innen.add(labBmi);
    innen.add(btnStart);
    // So kann die Meldung ueber die gesamte Breite gehen
    add(labMeldung, BorderLayout.SOUTH);
    // zusammenpacken und darstellen
    pack();
    setVisible(true);
  }

  @Override public void actionPerformed(ActionEvent ev)
  {
    // gehen wir mal davon aus, dass das Ereignis nur
    // vom Button kommen kann.
    if (txtGroesse.getText().length() > 0
        && txtGewicht.getText().length() > 0) {
      try {
        int groesse = Integer.parseInt(txtGroesse.getText());
        int gewicht = Integer.parseInt(txtGewicht.getText());
        double bmi = gewicht / (groesse*groesse / 10000.0);
        // Eine Nachkommastelle reicht beim BMI
        bmi = Math.round(bmi * 10.0) /10.0;
        labBmi.setText("BMI = " + bmi);
        if (bmi < 20.0) {
          labMeldung.setText("Untergewicht");
        } else if (bmi <= 25.0) {
          labMeldung.setText("Normalgewicht");
        } else if (bmi <= 30) {
          labMeldung.setText("Uebergewicht");
        } else if (bmi <= 40) {
          labMeldung.setText("Adipositas");
        } else {
          labMeldung.setText("Starke Adipositas");
        }
      } catch (NumberFormatException ex) {
        labMeldung.setText("Fehlerhafte Eingabe");
      }
    } else {
      labMeldung.setText("Fehlende Eingaben");
    }
  }

  public static void main(String[] args) {
    new BMI();
  }
}

