import javax.swing.*; 
import java.awt.GridLayout; 
import java.awt.BorderLayout; 
import java.awt.event.*; 

public class BMIAlter extends JFrame
                      implements ActionListener { 
  JTextField txtGroesse, txtGewicht; 
  JLabel labMeldung, labBmi; 
  JRadioButton radioMaennlich, radioWeiblich;
  JComboBox wahlAlter;

  @SuppressWarnings({"unchecked"})
  public BMIAlter() { 
    JLabel labGroesse, labGewicht;
    JButton btnStart; 

    setDefaultCloseOperation(EXIT_ON_CLOSE); 
    // der Hauptcontainer bekommt ein Borderlayout.
    setLayout(new BorderLayout());
    JPanel innen = new JPanel();
    add(innen, BorderLayout.CENTER);
    innen.setLayout(new GridLayout(5, 2));
    // erzeuge die Kontrollelemente
    // Radio fuer M/W
    radioMaennlich = new JRadioButton("maennlich");
    radioWeiblich = new JRadioButton("weiblich");
    ButtonGroup grpGeschlecht = new ButtonGroup();
    grpGeschlecht.add(radioMaennlich);
    grpGeschlecht.add(radioWeiblich);
    radioMaennlich.setSelected(true);
    // Die Labels
    labGroesse = new JLabel("Groesse (cm):"); 
    labGewicht = new JLabel("Gewicht (kg):"); 
    JLabel labAlter = new JLabel("Alter:"); 
    labMeldung = new JLabel(" "); 
    labBmi = new JLabel(" "); 
    // Die Eingabefelder
    txtGroesse = new JTextField(); 
    txtGewicht = new JTextField(); 
    // Die Combobox fuer das Alter
    String[] strAlterWahl = { "unter 25", "bis 34", "bis 44",
                              "bis 54", "bis 64", "ueber 65" };
    wahlAlter = new JComboBox(strAlterWahl);
    // Der Startbutton
    btnStart = new JButton("OK"); 
    // nur der Button ist aktiv
    btnStart.addActionListener(this); 
    // Zusammenbau aller Elemente
    innen.add(radioMaennlich); 
    innen.add(radioWeiblich); 
    innen.add(labGroesse); 
    innen.add(txtGroesse); 
    innen.add(labGewicht); 
    innen.add(txtGewicht); 
    innen.add(labAlter);
    innen.add(wahlAlter);
    innen.add(labBmi); 
    innen.add(btnStart); 
    // So kann die Meldung ueber die gesamte Breite gehen
    add(labMeldung, BorderLayout.SOUTH); 
    // zusammenpacken und darstellen
    pack();
    setVisible(true);
  } 

  public void actionPerformed(ActionEvent ev) 
  {
    // gehen wir mal davon aus, dass das Ereignis nur
    // vom Button kommen kann. 
    if (txtGroesse.getText().length() > 0 
    && txtGewicht.getText().length() > 0) { 
      try { 
        int groesse = Integer.parseInt(txtGroesse.getText()); 
        int gewicht = Integer.parseInt(txtGewicht.getText()); 
        double bmi = gewicht / (groesse*groesse / 10000.0); 
        // Eine Nachkommastelle reicht beim BMI
        bmi = Math.round(bmi * 10.0) /10.0;
        labBmi.setText("BMI = " + bmi);
        // korrigiere BMI bei Frauen
        if (radioWeiblich.isSelected()) {
           bmi++;
        }
        // Alterszuschlag
        int alter = wahlAlter.getSelectedIndex();
        if (alter > 0) bmi -= alter;
        if (bmi < 20.0) {
          labMeldung.setText("Untergewicht"); 
        } else if (bmi <= 25.0) {
          labMeldung.setText("Normalgewicht"); 
        } else if (bmi <= 30) { 
          labMeldung.setText("Uebergewicht"); 
        } else if (bmi <= 40) {
          labMeldung.setText("Adipositas"); 
        } else { 
          labMeldung.setText("Starke Adipositas"); 
        } 
      } catch (NumberFormatException ex) {
        labMeldung.setText("Fehlerhafte Eingabe"); 
      }
    } else { 
      labMeldung.setText("Fehlende Eingaben"); 
    } 
  } 

  public static void main(String[] args) {
    new BMIAlter();
  }
}

