import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.*;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.ButtonGroup;
import javax.swing.JTextField;

public class LEDVorwiderstand extends JFrame  implements ActionListener {

    String farbe[] = {"weiss", "rot", "gelb", "gruen", "blau"};
    double uLED[]  = { 4.0,     1.6,   2.2,    2.1,     2.9};
    JRadioButton radio[];

    JButton button = null;
    JTextField anzeige = null;
    JTextField batterie = null;
    JTextField maxI = null;

    public LEDVorwiderstand() {
        setLayout(new BorderLayout());
        JPanel panel = new JPanel();
        JPanel centerPanel = new JPanel();
        centerPanel.setLayout(new FlowLayout());
        panel.setLayout(new GridLayout(farbe.length,1));
        ButtonGroup gruppe = new ButtonGroup();
        radio = new JRadioButton[farbe.length];
        for (int i=0; i<farbe.length; i++) {
            radio[i] = new JRadioButton(farbe[i]);
            gruppe.add(radio[i]);
            panel.add(radio[i]);
        }
        centerPanel.add(panel);
        JPanel inputPanel = new JPanel();
        inputPanel.setLayout(new GridLayout(5,1));
        inputPanel.add(new JLabel("Batterie in V:"));
        batterie = new JTextField();
        inputPanel.add(batterie);
        inputPanel.add(new JLabel(""));
        inputPanel.add(new JLabel("Max. LED-Strom (mA):"));
        maxI = new JTextField("18");
        inputPanel.add(maxI);
        centerPanel.add(inputPanel);
        add(BorderLayout.CENTER, centerPanel);
        anzeige = new JTextField();
        add(BorderLayout.NORTH, anzeige);
        button = new JButton("Anzeigen");
        add(BorderLayout.SOUTH, button);
        button.addActionListener(this);

        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        pack();
        setVisible(true);
    }

    @Override public void actionPerformed(ActionEvent ev) {
        double uLed = 0.0;
        for (int i=0; i<farbe.length; i++) {
            if (radio[i].isSelected()) {
                uLed = uLED[i];
            }
        }
        double uBatterie = 0.0;
        double iLed = 0.0;
        String strUBatterie = batterie.getText();
        String strMaxI = maxI.getText();
        try {
            uBatterie = Double.parseDouble(strUBatterie);
            iLed = Double.parseDouble(strMaxI);
            double r = (uBatterie - uLed) / (iLed/1000);
            anzeige.setText(""+r);
        } catch(Exception e) {
            anzeige.setText("Unkorrekte Parameter!");
        }
    }

    public static void main(String[] args) {
        new LEDVorwiderstand();
    }
}

