import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;

public class BermudaSwing extends JFrame implements MouseListener {

    final int DISTANZ = 32;
    Insets in;
    SpielFeld sf = null;
    boolean spielEnde = false;    // ist das Spiel beendet worden?
    boolean neuesBild = true;    // ist das Spiel beendet worden?
    String StatusStr = "                ";

    Image leer, schiff, ziffer[];
    public static void main(String[] args) {
        BermudaSwing fenster = new BermudaSwing();
    }

    public BermudaSwing() {
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        addMouseListener(this); // fange die Mausereignisse
        addWindowListener(
            new WindowAdapter() {
                public void windowClosing(WindowEvent ev) {
                    if (!spielEnde) {
                        try {
                            FileOutputStream datei = new FileOutputStream("bermuda.game");
                            ObjectOutputStream out = new ObjectOutputStream(datei);
                            out.writeObject(sf);
                            out.close();
                        } catch(IOException ex) {
                            System.out.println(ex);
                        }
                    } // if !spielEnde
                    dispose();
                    System.exit( 0 );
                }
            }
        );
        try {
            FileInputStream datei = new FileInputStream("bermuda.game");
            ObjectInputStream in = new ObjectInputStream(datei);
            sf = (SpielFeld) in.readObject();
            in.close();
        } catch(Exception ex) {
            System.out.println(ex);
            sf = new SpielFeld();
        }
        setTitle("Bermuda");
        setSize((sf.MaxX+2)*DISTANZ,(sf.MaxY+4)*DISTANZ);
        setVisible(true);
        leer = Toolkit.getDefaultToolkit().getImage("leer.png");
        schiff = Toolkit.getDefaultToolkit().getImage("schiff.png");
        ziffer = new Image[9];
        for (int i=0; i<9; i++) {
            ziffer[i] = Toolkit.getDefaultToolkit().getImage("mark"+i+".png");
        }

    }

    public void paint(Graphics g) {
        in = getInsets();
        if (neuesBild) {
            g.clearRect(in.left, in.top, getSize().width, getSize().height);
            neuesBild = false;
        }
        String str;
        for (int i=0; i<sf.MaxX; i++) {
            for (int j=0; j<sf.MaxY; j++) {
                char c = sf.get(i, j);
                Image img=null;
                if (c >='0' && c <='8') {
                    img = ziffer[c-'0'];
                } else if (c==sf.SCHIFF) {
                    img = schiff;
                } else {
                    img = leer;
                }
                g.drawImage(img,in.left+(i+1)*DISTANZ-DISTANZ/2, 
                                in.top+(j+1)*DISTANZ-DISTANZ/2, this);
            }
        }
        g.drawString(StatusStr, in.left, in.top + (sf.MaxY+1) * DISTANZ);
    }

    @Override public void mouseClicked(MouseEvent me) {
        if (!spielEnde) {
            int suchX = (me.getX()-in.left-DISTANZ/2)/DISTANZ;
            int suchY = (me.getY()-in.top-DISTANZ/2)/DISTANZ;
            if (suchX>=0 && suchY>=0 && suchX<sf.MaxX && suchY<sf.MaxY) {
                char c = sf.suche(suchX, suchY);
                if (c==sf.SCHIFF) {
                    if (sf.alleGefunden()) {
                        spielEnde = true;
                        StatusStr = "Gewonnen! Mausklick: neues Spiel";
                    }
                }
            }
        } else {
            // sonderfall: Mausklick, um Sieg zu bestaetigen
            spielEnde = false;
            neuesBild = true;
            StatusStr = "                  ";
            sf = new SpielFeld(); //.neuesSpiel();
        }
        repaint();
    }
    // zur Realisierung des Interface, auch wenn wir die Methoden nicht brauchen...
    public void mouseReleased(MouseEvent me) { }
    public void mousePressed(MouseEvent me)  { }
    public void mouseEntered(MouseEvent me)  { }
    public void mouseExited(MouseEvent me)   { }
}

