import java.io.*;
public class DirMainGroesse {
    static void durchsuche(File dir, DirVisitor visitor) {
        // ist der uebergebene Name ueberhaupt ein Verzeichnis?
        if (!dir.isDirectory()) {
            throw new IllegalArgumentException(
                      "not a directory: " + dir.getName()
            );
        }
        // Eintritt in ein Verzeichnis: Der Visitor tritt ein
        visitor.betreten(dir);
        // Dateien des Verzeichnisses auslesen
        File[] eintrag = dir.listFiles(
            new FileFilter() {
                public boolean accept(File pathname) {
                    return true;
                }
            }
        );
        // Eine Schleife ueber alle enthaltenen Dateien
        for (int i = 0; i < eintrag.length; ++i) {
            if (eintrag[i].isDirectory()) {
                // Verzeichnis! Aufruf der Rekursion!
                durchsuche(eintrag[i], visitor);
            } else {
                // Normaler Eintrag einer Datei: Der Visitor besucht!
                visitor.besuchen(eintrag[i]);
            }
        }
        // Verzeichnis ausgelesen. Der Visitor geht
        visitor.verlassen(dir);
    }

    public static void main(String[] args) {
        // Uebergebenen Verzeichnisnamen auswerten
        File file = new File(args[0]);
        // Durchsuche rekursiv das Verzeichnis
        DirGroesseVisitor groesseVisitor = new DirGroesseVisitor();
        durchsuche(file, groesseVisitor);
        System.out.println("Groesse : " + groesseVisitor.getGroesse());
    }
}

