import java.io.*;

public class ListDir {

    static int tiefe = 0;

    void zeigName(String name, int tiefe) {
        for (int i=0; i<tiefe; i++) {
            System.out.print("  ");
        }
        System.out.println(name);
    }

    void durchsuche(File dir) {
        // ist der uebergebene Name ueberhaupt ein Verzeichnis?
        if (!dir.isDirectory()) {
            throw new IllegalArgumentException(
                      "not a directory: " + dir.getName()
            );
        }
        tiefe++; // Eintritt in ein Verzeichnis
        // Verzeichnisname anzeigen
        zeigName(dir.getName(), tiefe);
        // Dateien des Verzeichnisses auslesen
        File[] eintrag = dir.listFiles(
            new FileFilter() {
                public boolean accept(File pathname) {
                    return true;
                }
            }
        );
        // Eine Schleife ueber alle enthaltenen Dateien
        for (int i = 0; i < eintrag.length; ++i) {
            if (eintrag[i].isDirectory()) {
                // Verzeichnis! Aufruf der Rekursion!
                durchsuche(eintrag[i]);
            } else {
                // Normaler Eintrag einer Datei: Anzeigen
                zeigName(eintrag[i].getName(), tiefe);
            }
        }
        // Verzeichnis ausgelesen, Tiefe reduzieren
        tiefe--;
    }

    ListDir(String[] dateien) {
        for (String dateiname : dateien) {
            try {
                // Uebergebenen Verzeichnisnamen auswerten
                File file = new File(dateiname);
                // Durchsuche rekursiv das Verzeichnis
                durchsuche(file);
            } catch (IllegalArgumentException e) {
            }
        }
    }
    public static void main(String[] args) {
        new ListDir(args);
    }
}

