import java.util.Random;
import java.io.*;

class SpielFeld implements Serializable {

    final int MaxX = 9;
    final int MaxY = 7;
    private char feld[][] = null;
    final int MAXSCHIFF = 4;
    private Schiff schiff[] = null;
    final char SCHIFF = 'X';

    SpielFeld() {
        // Spielfeld vorbereiten
        feld = new char[MaxX][];
        for (int x=0; x<MaxX; x++) {
            feld[x] = new char [MaxY];
            for (int y=0; y<MaxY; y++) {
                feld[x][y] = '+';
            }
        }
        // Schiffe vorbereiten
        schiff = new Schiff[MAXSCHIFF];
        for (int i=0; i<MAXSCHIFF; i++) {
            schiff[i] = new Schiff();
        }
        // Schiffe verteilen
        Random zufall = new Random();
        for (int i=0; i<MAXSCHIFF; i++) {
            boolean kollidieren = false;
            do {
                int x = Math.abs(zufall.nextInt()) % MaxX;
                int y = Math.abs(zufall.nextInt()) % MaxY;
                schiff[i].setPos(x, y);
                kollidieren = false;
                for (int j=0; j<i; j++) {
                    if (schiff[j].istPos(x, y)) {
                        kollidieren = true;
                    }
                }
            } while (kollidieren);
        }
    }

    public char get(int x, int y) {
       return feld[x][y];
    }

    boolean alleGefunden() {
         boolean gefunden = true;
         for (int i=0; i<MAXSCHIFF; i++) {
             if (schiff[i].istGefunden()==false) {
                 gefunden = false;
             }
         }
         return gefunden;
    }

    // ----- Suche die Schiffe und melde die Anzahl der Richtungen -----
    public char suche(int posX, int posY) {
        final int NORD=0;
        final int SUED=1;
        final int OST=2;
        final int WEST=3;
        final int NORDOST=4;
        final int NORDWEST=5;
        final int SUEDOST=6;
        final int SUEDWEST=7;
        final int RICHTUNGEN=8;
        int richtung[] = new int[RICHTUNGEN];
        for (int i=0; i<MAXSCHIFF; i++) {
            int sx = schiff[i].getX();
            int sy = schiff[i].getY();

            if (sx == posX) {
                if (sy == posY) {
                    schiff[i].aufdecken();
                    feld[posX][posY] = SCHIFF;
                    return SCHIFF;
                } else if (sy < posY) {
                    richtung[NORD] = 1;
                } else {
                    richtung[SUED] = 1;
                }
            } else if (sy == posY) {
                if (sx < posX) {
                    richtung[OST] = 1;
                } else {
                    richtung[WEST] = 1;
                }
            } else if (sx-posX == sy-posY) {
                if (sx < posX) {
                    richtung[NORDOST] = 1;
                } else {
                    richtung[SUEDWEST] = 1;
                }
            } else if (sx-posX == posY-sy) {
                if (sx < posX) {
                    richtung[SUEDOST] = 1;
                } else {
                    richtung[NORDWEST] = 1;
                }
            }
        }
        int anzahl = 0;
        for (int i=0; i<RICHTUNGEN; i++) {
            anzahl += richtung[i];
        }
        feld[posX][posY] = (char)('0'+anzahl);
        return feld[posX][posY];
    }

    // debug only
    public void zeigSchiffe() {
         for (int i=0; i<MAXSCHIFF; i++) {
             schiff[i].zeig();
         }
    }
}

