import java.sql.*;
import java.util.Properties;

public class MultiInsertBonbon {
    final static String dbName = "Bonbonbude";
    final static String tableName = "Artikel";

    public MultiInsertBonbon() {
         try {
            Class.forName("org.apache.derby.jdbc.EmbeddedDriver");
        } catch (ClassNotFoundException e) {
            System.out.println("derby.jar fehlt. Programmende.");
            System.exit(1);
        }
    }
    public static void main(String args[]) {
        MultiInsertBonbon db = new MultiInsertBonbon();
        try{
            Connection dbConnect = db.connect();
            if (args.length == 3) {
                db.insert(dbConnect);
            }
            db.insert(dbConnect);
            dbConnect.close();   // Datenbank schliessen
        } catch (SQLException e) {
            System.out.println(e.toString());
            System.out.println("Status: " + e.getSQLState());
            System.out.println("Error: " + e.getErrorCode());
        }
    }
    public Connection connect() throws SQLException {
        Properties properties = new Properties();
        properties.put("user", "arnold");
        properties.put("password", "geheim");
        Connection dbConnect = DriverManager.getConnection(
                 "jdbc:derby:"+dbName, properties);
        return dbConnect;
    } 
    public void create(Connection connection) throws SQLException {
        System.out.println("Creating Table " + tableName); 
        Statement statement = connection.createStatement();
        statement.execute("create table "+ tableName +" ( "
              + " name  varchar(32), "
              + " preis dec(10,2), "
              + " menge int "
              + " )");
        statement.close();
    }
    public void insert(Connection connection) {
        try {
            PreparedStatement statement 
                    = connection.prepareStatement(
                    "insert into "+ tableName 
                    + " (name, preis, menge) VALUES (?,?,?)");
            statement.setString(1, "Oreganodrops");
            statement.setDouble(2, 0.48);
            statement.setLong(3, 30);
            statement.executeUpdate();
            statement.setString(1, "Peperonipralinen");
            statement.setDouble(2, 0.78);
            statement.setLong(3, 20);
            statement.executeUpdate();
            statement.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
    public void selectAll(Connection dbConnect) throws SQLException {

        PreparedStatement sqlBefehl = dbConnect.prepareStatement(
                    "SELECT name, preis, menge FROM artikel");
        ResultSet sqlErgebnis = sqlBefehl.executeQuery();
        while (sqlErgebnis.next()) {
            System.out.print("Name: ");
            System.out.print(sqlErgebnis.getString("name"));
            System.out.print(" | Preis: ");
            System.out.print(sqlErgebnis.getDouble("preis"));
            System.out.print(" | Menge: ");
            System.out.println(sqlErgebnis.getDouble("menge"));
        }
        sqlErgebnis.close(); // Ergebnismenge schliessen
    }
}

